//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

extern string TimeFrame            = "Current time frame";
extern int    Tenkan_Sen           = 9;
extern int    Kijun_Sen            = 26;
extern int    Senkou_span_B        = 52;
extern int    Price                = PRICE_CLOSE;
extern bool   Compare_Chinkou_Span = false;

//
//
//
//
//

double buffup[];
double buffdn[];
string indicatorFileName;
int    timeFrame;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
    SetIndexBuffer(0, buffup); SetIndexStyle(0, DRAW_HISTOGRAM);
    SetIndexBuffer(1, buffdn); SetIndexStyle(1, DRAW_HISTOGRAM);
       indicatorFileName = WindowExpertName();
       returnBars        = (TimeFrame=="returnBars");     if (returnBars) return(0);
       timeFrame         = stringToTimeFrame(TimeFrame);
       IndicatorShortName(timeFrameToString(timeFrame)+" ichimoku pooh");
    return(0);
}
int deinit()
{
    return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
           int limit = MathMin(MathMax(Bars-counted_bars,Kijun_Sen),Bars-1);
           if (returnBars) { buffup[0] = limit+1; return(0); }
           if (timeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   //
   //
   //
   //
   //
   
   for(int i = limit; i >=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double price  = iMA(NULL,timeFrame,1,0,MODE_SMA,Price,y);
      double ssa    = iIchimoku(NULL,timeFrame,Tenkan_Sen,Kijun_Sen,Senkou_span_B,MODE_SENKOUSPANA,y);
      double ssb    = iIchimoku(NULL,timeFrame,Tenkan_Sen,Kijun_Sen,Senkou_span_B,MODE_SENKOUSPANB,y);
      double tks    = iIchimoku(NULL,timeFrame,Tenkan_Sen,Kijun_Sen,Senkou_span_B,MODE_TENKANSEN  ,y);
      double kis    = iIchimoku(NULL,timeFrame,Tenkan_Sen,Kijun_Sen,Senkou_span_B,MODE_KIJUNSEN   ,y);
      double chs    = iIchimoku(NULL,timeFrame,Tenkan_Sen,Kijun_Sen,Senkou_span_B,MODE_CHINKOUSPAN,y);
      double cloudu = MathMax(ssa,ssb);
      double cloudd = MathMin(ssa,ssb);
         buffup[i] = EMPTY_VALUE;
         buffdn[i] = EMPTY_VALUE;
         bool adda = true;
         bool addb = true;
         if (Compare_Chinkou_Span)
         {
             adda = (chs> 0 && chs>price);
             addb = (chs> 0 && chs<price);
         }
         Comment(chs);
         if ((price > cloudu) && (tks>kis) && adda) buffup[i] = 1;
         if ((price < cloudd) && (tks<kis) && addb) buffdn[i] = 1;
   }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

